<?php

class DegustationIterator implements Iterator, Countable {
    protected $id_degustation = 1;
    private MyPDO $myPDODegustation;

    public function __construct()
    {
        $this->myPDODegustation = new MyPDO($_ENV['host'], $_ENV['db'], $_ENV['user'], $_ENV['password'], 'Degustation');
    }

    public function count(){
        return $this->myPDODegustation->count();
    }

    public function current(){
        return $this->myPDODegustation->get("id_degustation",$this->id_degustation);
    }

    public function key(){
        return $this->id_degustation;
    }

    public function next(){
        $val = $this->myPDODegustation->get("id_degustation",0);
        $this->id_degustation++;
        if( $this->id_degustation < $this->myPDODegustation->getMax("id_degustation") && $this->myPDODegustation->get("id_degustation",$this->id_degustation) == $val )
            $this->next();
    }

    public function rewind(){
        $this->id_degustation = 1;
    }

    public function valid(){
        return $this->id_degustation > 0 && $this->id_degustation <= $this->myPDODegustation->getMax("id_degustation");
    }
}
?>
